/*
Copyright 2014 Marco Fantini
This file is part of DEAL.
DEAL is free software : you can redistribute it and / or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

DEAL is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with DEAL.If not, see <http://www.gnu.org/licenses/>.
*/

#include "SeqTree.h"

using namespace std;

namespace SeqTree
{
	
	void parsefileforgroup()
	{
		ifstream File;
		string ifilename = par.iFileName;
		clock_t StartTime = clock();
		unsigned long Iterations = 0;


		File.open(ifilename, ios::in);
		Seqnode *seq = SeqROOT;
		Groupnode *GN_r1 = NULL;
		Groupnode *GN_r2 = NULL;
		Groupnode *GN_R = NULL;
		
		ofstream ofile_r1;
		string ofilename_r1;
		
		ofstream ofile_r2;
		string ofilename_r2;

		ofstream ofile_R;
		string ofilename_R;

		if (par.splitReads){
			ofilename_r1 = string(ifilename);
			ofilename_r1 += "_Group_r1_2ndstep.txt";
			cout << "output: " << ofilename_r1.c_str() << '\n';
			ofile_r1.open(ofilename_r1.c_str(), ios::out);

			ofilename_r2 = string(ifilename);
			ofilename_r2 += "_Group_r2_2ndstep.txt";
			cout << "output: " << ofilename_r2.c_str() << '\n';
			ofile_r2.open(ofilename_r2.c_str(), ios::out);

		};

		ofilename_R = string(ifilename);
		ofilename_R += "_Group_2ndstep.txt";
		cout << "output: " << ofilename_R.c_str() << '\n';
		ofile_R.open(ofilename_R.c_str(), ios::out);

		ofstream ofile_stat;
		string ofilename_stat;
		ofilename_stat = string(ifilename);
		ofilename_stat += "_Stat_2ndstep.txt";
		cout << "output: " << ofilename_stat.c_str() << '\n';
		ofile_stat.open(ofilename_stat.c_str(), ios::out);


		ofstream ofile_DF;
		string ofilename_DF;
		ofilename_DF = string(ifilename);
		ofilename_DF += "_DF_2ndstep.tsv";
		cout << "output: " << ofilename_DF.c_str() << '\n' << '\n';
		ofile_DF.open(ofilename_DF.c_str(), ios::out);

		string Header;
		string Header2;
		string Sequence;
		string Quality;		

		while (getline(File, Header) && ((!par.test) || (Iterations < par.MaxSequences)))
		{
			getline(File, Sequence);
			getline(File, Header2);
			getline(File, Quality);
			uint16_t sl = (uint16_t)Sequence.length();

			if (sl){ 
				GN_r1 = seq->Group_r1;
				GN_r2 = seq->Group_r2;
				GN_R  = seq->Group_R;
				CompileSequence(Header, Quality, Sequence, seq, sl);
				if (par.splitReads){
					ofile_DF << seq->ID << "\t" << seq->Group_R->ID << "\t" << seq->Group_R->Depth << "\t" << seq->Group_r1->ID << "\t" << seq->Group_r2->ID << "\t" << seq->Group_r1->Depth << "\t" << seq->Group_r2->Depth << "\n";
					if (GN_R->count == GN_R->TotCount)		RecursiveGroupWrite(GN_R , 0, ofile_R , 0);
					if (GN_r1->count == GN_r1->TotCount)	RecursiveGroupWrite(GN_r1, 0, ofile_r1, 1);
					if (GN_r2->count == GN_r2->TotCount)	RecursiveGroupWrite(GN_r2, 0, ofile_r2, 2);
				};
				if (!par.splitReads){
					ofile_DF << seq->ID << "\t" << seq->Group_R->ID << "\t" << seq->Group_R->Depth << "\n";
					if (GN_R->count == GN_R->TotCount)		RecursiveGroupWrite(GN_R, 0, ofile_R, 0);
				};
			};
			Iterations++;
			seq = seq->next;
			if (!(Iterations % 10000)) cerr << Iterations << "\r";
		};

		unsigned long cumSeq = 0;
		cout << "Group statistic:\n";
		if (par.splitReads){
			cumSeq = 0;
			cout << "Total sequences number = " << TOTSeq << "\nTotal groups number read1 = " << TOTGroup_r1_2ndstep << "\n";
			ofile_stat << "#Group statistic read1\n";
			ofile_stat << "Total sequences number = " << TOTSeq << "\nTotal groups number r1 = " << TOTGroup_r1_2ndstep << "\n";
			for (std::map<unsigned long, unsigned long>::iterator it = ngroup_r1_2ndstep.begin(); it != ngroup_r1_2ndstep.end(); ++it){
				if (it->first < 20) cout << "Group r1[" << it->first << "] = " << it->second << "\n";
				ofile_stat << "Group\tr1\t" << it->first << "\t" << it->second << '\n';
				cumSeq += it->first * it->second;
			};

			cumSeq = 0;
			cout << "Total sequences number = " << TOTSeq << "\nTotal groups number read2 = " << TOTGroup_r2_2ndstep << "\n";
			ofile_stat << "#Group statistic read2\n";
			ofile_stat << "Total sequences number =  " << TOTSeq << "\nTotal groups number r2 = " << TOTGroup_r2_2ndstep << "\n";
			for (std::map<unsigned long, unsigned long>::iterator it = ngroup_r2_2ndstep.begin(); it != ngroup_r2_2ndstep.end(); ++it){
				if (it->first < 20) cout << "Group r2[" << it->first << "] = " << it->second << "\n";
				ofile_stat << "Group\tr2\t" << it->first << "\t" << it->second << '\n';
				cumSeq += it->first * it->second;
			};

		};

		cumSeq = 0;
		cout << "Total sequences number = " << TOTSeq << "\nTotal groups number = " << TOTGroup_R_2ndstep << "\n";
		ofile_stat << "#Group statistic\n";
		ofile_stat << "Total sequences number = " << TOTSeq << "\nTotal groups number = " << TOTGroup_R_2ndstep << "\n";
		for (std::map<unsigned long, unsigned long>::iterator it = ngroup_R_2ndstep.begin(); it != ngroup_R_2ndstep.end(); ++it){
			if (it->first < 20) cout << "Group R[" << it->first << "] = " << it->second << "\n";
			ofile_stat << "Group\tR\t" << it->first << "\t" << it->second << '\n';
			cumSeq += it->first * it->second;
		};

		if (par.splitReads){
			ofile_r1.close();
			ofile_r2.close();
		};
		ofile_R.close();

		ofile_stat.close();
		File.close();

	};

	void CompileSequence(string Header, string Quality, string Sequence, Seqnode *seqN, unsigned int SL)
	{
		int tile = 0;
		int index = 0;
		char *dup = NULL;
		std::vector<char*> info;
		if (er.given){
			char * pch = NULL;
			char * np = NULL;

			dup = _strdup(Header.c_str());
			pch = strtok_s(dup, ": ", &np);
			while (pch != NULL)
			{
				info.push_back(pch);
				pch = strtok_s(NULL, ": ", &np);
			};
			//                                   4                       10
			//@HWI-M00772R:16:000000000-ABFEH:1:2105:22710:13121 1:N:0:TCAGCG
			tile = er.mapTile[std::string(info[4])];
			index = er.mapIndex[std::string(info[10])];
		};
		//if (tile != 0) cout << tile;
		//if (index != 0) cout << index;
		for (unsigned int i = par.ReadBoundariers.r1start; i < par.ReadBoundariers.r1end; ++i)
		{
			if (i < SL){
				Sequence[i] = Mappa[(unsigned int)Sequence[i]];
				if (Quality[i] - 33 <= par.QThresh)
				{
					Sequence[i] |= inc;
				};
				if (er.given){
					if (i < er.npos) {
						if (er.ER[index][tile][i] >= par.erThresh)
						{
							Sequence[i] |= inc;
						};
					}

					if (par.vl){
						if ((SL - 1) - i < er2.npos) {
							if (er2.ER[index][tile][(SL - 1) - i] >= par.erThresh)
							{
								Sequence[i] |= inc;
							};
						}
					}
				};
			}
			//else {
			//	Sequence[i] = 0;
			//};
		};
		for (unsigned int i = par.ReadBoundariers.r2start; i < par.ReadBoundariers.r2end; ++i)
		{
			if (i < SL) {
				Sequence[i] = Mappa[(unsigned int)Sequence[i]];
				
				if (Quality[i] - 33 <= par.QThresh)
				{
					Sequence[i] |= inc;
				};
				if (er.given){
					if (er.ER[index][tile][i] >= par.erThresh)
					{
						Sequence[i] |= inc;
					};
				};
			}
			//else {
			//	Sequence[i] = 0;
			//};
		};
		free(dup);


		char * cSeq_r1 = NULL;
		char * cSeq_r2 = NULL;
		char * cSeq_R = NULL;
		Groupnode *GN_r1 = NULL;
		Groupnode *GN_r2 = NULL;
		Groupnode *GN_R = NULL;
		//cout << par.ReadBoundariers.r1start << " " << par.ReadBoundariers.r1end << " " << par.ReadBoundariers.r1length << " " << par.ReadBoundariers.r2start << " " << par.ReadBoundariers.r2end << " " << par.ReadBoundariers.r2length << " " << par.ReadBoundariers.sl << "\n";
		cSeq_R = (char *)calloc((par.ReadBoundariers.sl + 1) , sizeof(char));
		int Rltrim;
		int r1ltrim;
		int r2ltrim;
		if (par.ReadBoundariers.r1start > SL){
			//vuoto
			Rltrim = 0;
			r1ltrim = 0;
			r2ltrim = 0;
		}
		if ((par.ReadBoundariers.r1start <= SL) & (par.ReadBoundariers.r1end > SL)){
			memcpy(cSeq_R, Sequence.c_str() + par.ReadBoundariers.r1start, (SL - par.ReadBoundariers.r1start) * sizeof(char));
			Rltrim = SL - par.ReadBoundariers.r1start;
			r1ltrim = SL - par.ReadBoundariers.r1start;
			r2ltrim = 0;
		}
		if ((par.ReadBoundariers.r1end <= SL) & (par.ReadBoundariers.r2start > SL)){
			memcpy(cSeq_R, Sequence.c_str() + par.ReadBoundariers.r1start, par.ReadBoundariers.r1length * sizeof(char));
			Rltrim = par.ReadBoundariers.r1length;
			r1ltrim = par.ReadBoundariers.r1length;
			r2ltrim = 0;
		}
		if ((par.ReadBoundariers.r2start <= SL) & (par.ReadBoundariers.r2end > SL)){
			memcpy(cSeq_R, Sequence.c_str() + par.ReadBoundariers.r1start, (SL - par.ReadBoundariers.r1start) * sizeof(char));
			memcpy(cSeq_R + par.ReadBoundariers.r1length, Sequence.c_str() + par.ReadBoundariers.r2start, (SL - par.ReadBoundariers.r2start) * sizeof(char));
			Rltrim = par.ReadBoundariers.r1length + (SL - par.ReadBoundariers.r2start);
			r1ltrim = par.ReadBoundariers.r1length;
			r2ltrim = SL - par.ReadBoundariers.r2start;
		}
		if (par.ReadBoundariers.r2end <= SL) {
			memcpy(cSeq_R, Sequence.c_str() + par.ReadBoundariers.r1start, (SL - par.ReadBoundariers.r1start) * sizeof(char));
			memcpy(cSeq_R + par.ReadBoundariers.r1length, Sequence.c_str() + par.ReadBoundariers.r2start, par.ReadBoundariers.r2length * sizeof(char));
			Rltrim = par.ReadBoundariers.r1length + par.ReadBoundariers.r2length;
			r1ltrim = par.ReadBoundariers.r1length;
			r2ltrim = par.ReadBoundariers.r2length;
		}

		

		//cSeq_R[Rltrim] = 0;		ho callocato
		GN_R = seqN->Group_R;
		RecursiveGroupSearch(cSeq_R, seqN, GN_R, 0, Rltrim, 0);

		if (par.splitReads){
			cSeq_r1 = (char *)calloc((par.ReadBoundariers.r1length + 1) , sizeof(char));
			cSeq_r2 = (char *)calloc((par.ReadBoundariers.r2length + 1) , sizeof(char));

			memcpy(cSeq_r1, Sequence.c_str() + par.ReadBoundariers.r1start, r1ltrim * sizeof(char));
			memcpy(cSeq_r2, Sequence.c_str() + par.ReadBoundariers.r2start, r2ltrim * sizeof(char));

			//cSeq_r1[r1ltrim] = 0;		ho callocato
			//cSeq_r2[r2ltrim] = 0;		ho callocato

			GN_r1 = seqN->Group_r1;
			GN_r2 = seqN->Group_r2;

			RecursiveGroupSearch(cSeq_r1, seqN, GN_r1, 0, r1ltrim, 1);
			RecursiveGroupSearch(cSeq_r2, seqN, GN_r2, 0, r2ltrim, 2);

		};
	};
	
	void RecursiveGroupSearch(char *cSeq, Seqnode *seq, Groupnode *GN, uint16_t Depth, int SL, int F)
	{
		if (GN->count == 0){
			GN->count = 1;
			GN->DefSeq = cSeq;
			setgroup(seq, GN, F);
		}else{
			int SL2 = (int)strlen(GN->DefSeq);
			char flag = CheckCompatibility(cSeq, GN->DefSeq, SL, SL2);
			if (flag & 0x01){ //se non  compatibile
				GN->TotCount -= 1;
				if (GN->SubGroup == NULL){
					Groupnode *newGnode = (Groupnode *)malloc(sizeof(Groupnode));
					GN->SubGroup = newGnode;
					newGnode->ID = GN->ID;
					newGnode->Depth = Depth + 1;
					newGnode->next = NULL;
					newGnode->SubGroup = NULL;
					newGnode->TotCount = 1;
					newGnode->count = 1;
					newGnode->DefSeq = cSeq;
					GN = newGnode;
					setgroup(seq, GN, F);
				}else{
					GN->SubGroup->TotCount += 1;
					RecursiveGroupSearch(cSeq, seq, GN->SubGroup, Depth +1, SL, F);
				};
			}else if (flag & 0x02){
				MergeSequences(GN->DefSeq, cSeq, SL);
					GN->count += 1;
					setgroup(seq, GN, F);
					free(cSeq);
			}else{ //flag == 0 o flag non implementate/non utili
					GN->count += 1;
					setgroup(seq, GN, F);
					free(cSeq);
			};
		};
	};
	
	char CheckCompatibility(char *Sequence, char *Sequence2, int SL, int SL2)
	{
		char flag = false; //0x01 Incompatibilit/0x02 Mutazione seq1/0x04 Mutazione seq2 /0x08 Inserzione seq1/0x0f Inserzione seq2/0x10 Delezione seq1/0x11 Delezione seq2/
		unsigned char tmp = inc;
		//unsigned int SL = strlen(Sequence);
		//unsigned int SL2 = strlen(Sequence2);
		if (SL != SL2) {
			return(0x01);
		}

		for (unsigned int p = 0; p < (unsigned int)SL; ++p)
		{
			register unsigned char cSC = Sequence[p];
			register unsigned char cSC2 = Sequence2[p];
			if (cSC == cSC2)
			{
			
			}else if ((cSC & inc) | (cSC2 & inc)){
				if (cSC & inc){// se c' incertezza nel primo
					if (cSC != (cSC | cSC2)){		// e il secondo porta nuova informazione
						flag |= 0x02;				// mismatch nel primo
					};
				};
				if (cSC2 & inc) flag |= 0x04; //mismatch nel secondo
			}else{
				//sequenze diverse
				//+delezioni e inserzioni
				flag |= 0x01;
				return(flag);
			};
		};
		return(flag);
	};	
	
	void MergeSequences(char *Sequence, char *Sequence2, int SL)
	{
		//unsigned int SL = strlen(Sequence);
		for (unsigned int p = 0; p < (unsigned int)SL; ++p)
		{
			if (Sequence[p] != Sequence2[p])
			{
				if (Sequence[p] & inc)
				{
					if (Sequence2[p] & inc)
					{
						Sequence[p] |= Sequence2[p];
					}else{
						Sequence[p] = Sequence2[p];
					};
				};
			};
		};
	};	

	void RecursiveGroupWrite(Groupnode *GN, uint16_t Depth, ofstream &oFile, int F)
	{
		
		
		if (F == 0){
			ngroup_R_2ndstep[GN->count]++;
			TOTGroup_R_2ndstep++;
		} else if(F == 1){
			ngroup_r1_2ndstep[GN->count]++;
			TOTGroup_r1_2ndstep++;
		} else if(F == 2){
			ngroup_r2_2ndstep[GN->count]++;
			TOTGroup_r2_2ndstep++;
		};

		if (par.protan)  ProteinParseSequence(GN, F);
		uint16_t j = 0;
		while (GN->DefSeq[j]) //!= 0
			{
				GN->DefSeq[j] = Decompile[(GN->DefSeq[j++])];
			};

		oFile << ">Group:" << GN->ID << "-" << Depth << "x" << GN->TotCount << "\n" << GN->DefSeq << "\n";

		Groupnode *SG = GN->SubGroup;
		//-------------------vuoi veramente cancellare l'intera struttura?-------------------------
		free(GN->DefSeq);
		free(GN);

		//tail-end recursion
		if (SG != NULL) RecursiveGroupWrite(SG, Depth + 1, oFile, F);

	};

	void setgroup(Seqnode *seq, Groupnode *GN, int F)
	{
		if (F == 0) seq->Group_R = GN;
		else if (F == 1) seq->Group_r1 = GN;
		else if (F == 2) seq->Group_r2 = GN;
	}
}
